using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Hosting;

namespace TestProject
{
    /// <summary>
    /// 
    /// </summary>
    public class Startup
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - Configuration

        /// <summary>
        /// 
        /// </summary>
        public IConfiguration Configuration { get; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - Startup(configuration)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="configuration"></param>
        public Startup(IConfiguration configuration)
        {
            Configuration = configuration;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  ÷ ϱ - ConfigureServices(services)

        /// <summary>
        ///  ÷ ϱ
        /// </summary>
        /// <param name="services"> ÷</param>
        public void ConfigureServices(IServiceCollection services)
        {
            services.AddControllersWithViews();
        }

        #endregion
        #region ϱ - Configure(app, environment)

        /// <summary>
        /// ϱ
        /// </summary>
        /// <param name="app">ø̼ </param>
        /// <param name="environment"> ȣƮ ȯ</param>
        public void Configure(IApplicationBuilder app, IWebHostEnvironment environment)
        {
            app.Map
            (
                "/level1",
                app => 
                {
                    app.Map
                    (
                        "/level2a",
                        app2 =>
                        {
                            app2.Run
                            (
                                async context =>
                                {
                                    await context.Response.WriteAsync("Map /level1/level2a");
                                }
                            );
                        }
                    );

                    app.Map
                    (
                        "/level2b",
                        app2 =>
                        {
                            app2.Run
                            (
                                async context =>
                                {
                                    await context.Response.WriteAsync("Map /level1/level2b");
                                }
                            );
                        }
                    );

                    app.Run
                    (
                        async context =>
                        {
                            await context.Response.WriteAsync("Map /level1");
                        }
                    );
                }
            );

            app.Run
            (
                async context =>
                {
                    await context.Response.WriteAsync("Hello from non-Map delegate.");
                }
            );
        }

        #endregion
    }
}